<?php

/*
 * maemo.org user list - outputs a CSV file of all maemo.org user
 * profiles for use in Hermes.
 *
 * Developed by slauwers for aflegg.
 * Further modifications by Andrew Flegg.
 *
 * Copyright (c) Sebastian Lauwers 2010.
 * Copyright (c) Andrew Flegg <andrew@bleb.org> 2010.
 * Released under the Artistic Licence.
 */

$BASE_URL = 'http://maemo.org/profile/list/?org_openpsa_qbpager_net_nehmer_account_list_page=';

for ($i = 1; $i < 250; $i++) {
    $url = $BASE_URL.$i;

    $doc = new DOMDocument();
    @$doc->loadHTMLFile($url);

    $table = $doc->getElementsByTagName('tbody');
    $rows = $table->item(0)->childNodes;

    if (!is_null($rows)) {
        foreach ($rows as $row) {
            $columns = $row->childNodes;

            if (!is_null($columns)) {
                $img = $columns->item(0)->getElementsByTagName('img')->item(0);
                $img_url = $img->getAttribute('src');
                $img_url = $img_url == 'http://static.maemo.org/style_maemo2009/img/profile/default-icon.png' ? '' : $img_url;

                $element = $columns->item(2)->getElementsByTagName('a')->item(0);
                $username = $element->nodeValue;
                $user_url = $element->getAttribute('href');

                $fullname = trim($columns->item(4)->nodeValue);

                $title = trim($columns->item(6)->nodeValue);

                $karma = intval(trim($columns->item(8)->nodeValue));

                if ($fullname || $img_url)
                    echo "$username,$fullname,http://maemo.org$user_url,$title,$karma,$img_url\n";
            }
        }	
    }
}
?>

